#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> oset;
using ll = long long;
mt19937 rnd(52);
ll mod = 998244353;
int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    ios::sync_with_stdio(0);
#endif
    int t;
    cin >> t;
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    bool f = true;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if ((a[i]-a[0])%2 != 0) {
            f = false;
        }
    }
    string s;
    cin >> s;
    if (m%2 == 0) {
        cout << "No\n";
        return 0;
    } else {
        cout << "Yes\n";
        cout << m/2+1 << '\n';
        cout << 1 << '\n' << m/2 << ' ' << m/2+1 << endl;
    }
    return 0;
}